'PIC 16F628A    DS18B20
Define CONF_WORD = %10000101010000

'  
OPTION_REG = %11000111
'  
CMCON = %00000111

' PORTA (/)
TRISA = %00100000
PORTA = %00000000
' PORTB (/)
TRISB = %11110000

'   
Symbol tr_0 = TRISA.0
Symbol tr_1 = TRISA.1
Symbol tr_2 = TRISA.6
Symbol tr_3 = TRISA.7

'   
Symbol clear = PORTB.6

'   ( ) 
Dim t(32) As Byte

'    ()
Dim d0 As Byte
Dim d1 As Byte
Dim d2 As Byte
Dim d3 As Byte

'  EEPROM  ( ) 
Dim i As Byte
For i = 0 To 31
	Read i, t(i)
Next i

'  ,    " "
Dim ff As Bit

' 
Dim temp As Word
'    10
Dim temp10 As Word

' 
'Dim temp_a As Single

'   ,    1000     
Dim part As Word

'     
Dim finish As Bit

' 0 (LSB) scratchpad
Dim lsb As Byte
' 1 (MSB) scratchpad
Dim msb As Byte

Dim n As Byte

'   
Define LCD_LINES = 4
'    
Define LCD_CHARS = 16
'  4- 
Define LCD_BITS = 4
'    
Define LCD_DREG = PORTB
' 4  
Define LCD_DBIT = 0
'     RS 
Define LCD_RSREG = PORTA
'     RS 
Define LCD_RSBIT = 2
'     RW 
Define LCD_RWREG = PORTA
'     RW 
Define LCD_RWBIT = 3
'     E 
Define LCD_EREG = PORTA
'     E 
Define LCD_EBIT = 4

'    1-Wire
Define 1WIRE_REG = PORTB
' 
Define 1WIRE_BIT = 7

' ,  
Lcdinit LcdCurOff
'  
Lcdcmdout LcdClear

'  
Lcddefchar 0, %01100, %10010, %10010, %01100, %00000, %11110, %00000, %00000  '0
Lcddefchar 1, %01110, %10001, %10001, %01110, %00000, %00000, %00000, %00000  '0
Lcddefchar 2, %01111, %10001, %10001, %01111, %10001, %10001, %10001, %00000  '
Lcddefchar 3, %01110, %10001, %00001, %00010, %00001, %10001, %01110, %00000  '
Lcddefchar 4, %10001, %10001, %10001, %10011, %10101, %11001, %10001, %00000  '

' 
loop:

'  SB1 
If Not clear Then

	'     
	tr_0 = 0
	tr_1 = 1
	tr_2 = 1
	tr_3 = 1
	
	'  1-Wire
	1wireInit
	'   DS18B20
	1wireSendByte 0x33
	'  
	1wireGetByte t(0), t(1), t(2), t(3), t(4), t(5), t(6), t(7)
	'  EEPROM    1
	For i = 0 To 7
		Write i, t(i)
	Next i
	
	'  2- 
	tr_0 = 1
	tr_1 = 0
	1wireInit
	1wireSendByte 0x33
	1wireGetByte t(8), t(9), t(10), t(11), t(12), t(13), t(14), t(15)
	For i = 8 To 15
		Write i, t(i)
	Next i

	'  3- 
	tr_1 = 1
	tr_2 = 0
	1wireInit
	1wireSendByte 0x33
	1wireGetByte t(16), t(17), t(18), t(19), t(20), t(21), t(22), t(23)
	For i = 16 To 23
		Write i, t(i)
	Next i

	'  4- 
	tr_2 = 1
	tr_3 = 0
	1wireInit
	1wireSendByte 0x33
	1wireGetByte t(24), t(25), t(26), t(27), t(28), t(29), t(30), t(31)
	For i = 24 To 31
		Write i, t(i)
	Next i
	
	'  
	tr_0 = 0
	tr_1 = 0
	tr_2 = 0
	tr_3 = 0
	
	' 1 .
	WaitMs 1000
	
Endif

'1
1wireInit
'        () 
1wireSendByte 0xcc, 0x44

'  
loop2:
1wireGetBit finish
If finish = 0 Then Goto loop2

' 
For i = 0 To 3
	1wireInit
	
	'      
	Select Case i
	Case 0
		1wireSendByte 0x55, t(0), t(1), t(2), t(3), t(4), t(5), t(6), t(7), 0xbe
	Case 1
		1wireSendByte 0x55, t(8), t(9), t(10), t(11), t(12), t(13), t(14), t(15), 0xbe
	Case 2
		1wireSendByte 0x55, t(16), t(17), t(18), t(19), t(20), t(21), t(22), t(23), 0xbe
	Case 3
		1wireSendByte 0x55, t(24), t(25), t(26), t(27), t(28), t(29), t(30), t(31), 0xbe
	EndSelect
	
	'   
	1wireGetByte lsb, msb

	'     
	ff = 0
	If lsb = msb Then
		If lsb = %11111111 Then
			'     
			ff = 1
			Goto label
		Endif
	Endif

	'    
	temp = ShiftRight(lsb, 4)
	n = ShiftLeft(msb, 4)
	temp = temp + n

	'  
	If msb.7 Then
		temp = 255 - temp
		lsb = 255 - lsb
	Endif
	
	'    
	If lsb.3 Then part = 5000 Else part = 0
	If lsb.2 Then part = part + 2500
	If lsb.1 Then part = part + 1250
	If lsb.0 Then part = part + 625

	'    10
	temp10 = temp * 10 + part / 1000

	'       
	'If msb.7 Then temp_a = 0-temp - part / 10000 Else temp_a = temp + part / 10000

	'       
	d0 = temp10 / 1000
	temp10 = temp10 Mod 1000
	d1 = temp10 / 100
	temp10 = temp10 Mod 100

	'   0     ?
	If d0 = 0 Then
		' 
		d0 = 13
		If d1 = 0 Then
			'  
			If msb.7 Then d1 = 12 Else d1 = 13
		Else
			'  
			If msb.7 Then d0 = 12  ' "-"
		Endif
	Endif
	
	d2 = temp10 / 10
	temp10 = temp10 Mod 10
	d3 = temp10

	label:

	'  
	Select Case i
	Case 0
		'  ,  
		Lcdcmdout LcdLine1Home
		' 
		Lcdout "N", 0, "1"
		'  8- 
		Lcdcmdout LcdLine1Pos(8)
	Case 1
		Lcdcmdout LcdLine2Home
		Lcdout "N", 0, "2"
		Lcdcmdout LcdLine2Pos(8)
	Case 2
		Lcdcmdout LcdLine3Home
		Lcdout "N", 0, "3"
		Lcdcmdout LcdLine3Pos(8)
	Case 3
		Lcdcmdout LcdLine4Home
		Lcdout "N", 0, "4"
		Lcdcmdout LcdLine4Pos(8)
	EndSelect

	'    ?
	If ff = 0 Then
		'      
		If d0 <> 13 Then
			If d0 = 12 Then
				Lcdout " -"
			Else
				Lcdout " ", #d0
			Endif
		Else
			Lcdout "  "
		Endif
		
		If d1 <> 13 Then
			If d1 = 12 Then
				Lcdout "-"
			Else
				Lcdout #d1
			Endif
		Else
			Lcdout " "
		Endif

		Lcdout #d2, ".", #d3, " ", 1, "C"

	Else
		' 
		Lcdout "HET CB", 2, 3, 4
	Endif

Next i

Goto loop

End                                               
